]> rtime.felk.cvut.cz Git - can-benchmark.git/blob - gw-tests/lib.sh
Do not invoke gnuplot when there is nothing to plot
[can-benchmark.git] / gw-tests / lib.sh
1 set -e
2
3 COUNT=10000
4
5 OPT_TRAFFIC=oneatatime
6
7 error() {
8     echo $1 >&2
9     exit 1
10 }
11
12 while [ $# -gt 0 ]; do
13     case "$1" in
14         -P) OPT_PLOT_DISABLE=1; shift;;
15         -p) OPT_PLOT_ONLY=1; shift;;
16         -X|--no-x11-plot) OPT_NO_X11=1; shift;;
17         -t) case "$2" in
18                 all|flood|50|oneatatime) OPT_TRAFFIC=$2;;
19                 *) error "Unknown traffic specification: $2";;
20             esac;
21             shift 2;;
22     esac
23 done
24
25 PATH=$PWD/../_compiled/bin/:$PATH
26
27 sshgw() {
28     local socket="$HOME/.ssh/cangw-connection"
29
30     if [[ ! -S $socket ]] || ! ssh -x -a -S $socket root@192.168.2.3 true; then
31         # Create master connection to speed up subsequenct command.
32         # The ssh is put into background and the connection is closed
33         # after 10 minutes)
34         ssh -f -M -S $socket root@192.168.2.3 sleep 600 > /dev/null 2>&1
35     fi
36     ssh -x -a -S $socket root@192.168.2.3 "$@"
37 }
38
39 cleanupgw() {
40     sshgw 'cangw -F'
41 }
42
43 _plot() {
44     local testname=`basename $0 .sh`
45
46     plot_cmds | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n($kvers)\"/" > plot.gp
47     if [[ ! -s plot.gp ]]; then return; fi
48     if [ -z "$OPT_NO_X11" ]; then
49         echo "set terminal x11 enhanced; $(< plot.gp)" | gnuplot -persist
50     fi
51     I=''
52     echo 'set terminal postscript color eps enhanced size 6cm,4cm lw 1 "Times-Roman" 10;' \
53         'set lmargin 8;' \
54         "$(< plot.gp)" | gnuplot > ${testname}$I.eps
55     echo "set terminal postscript color eps enhanced;" \
56         "$(< plot.gp)" | gnuplot | epstopdf --filter > ${testname}$I.pdf
57     mkdir -p thumb
58     convert -density 30  -gamma 0.5 -quality 90 -type Palette -depth 8 ${testname}$I.pdf thumb/${testname}$I.png
59     convert -density 150 -gamma 0.7 -quality 90 -type Palette -depth 8 ${testname}$I.pdf ${testname}$I.png
60
61 }
62
63 echo_plot() {
64     plot=$1
65     [[ "$_plot_separator" ]] && echo ", \\"
66     _plot_separator=t
67     echo -n "    " $plot
68 }
69
70 traffic_and_length() {
71     local opts
72     case $OPT_TRAFFIC in
73         flood) opts='';;
74         50)        opts="-p $((2*(44+$1*8)))";;
75         oneatatime)        opts="-o";;
76         *) error "Unknown traffic specification"
77     esac
78     echo $opts -l $1
79 }
80
81 _run() {
82     if [[ ! "$OPT_PLOT_ONLY" ]]
83     then kernel_versions=$(sshgw uname -r)
84     else kernel_versions=$(ls results/by-kern)
85     fi
86     if [[ $OPT_TRAFFIC = all ]]
87     then traffics="flood 50 oneatatime"
88     else traffics=$OPT_TRAFFIC
89     fi
90     for OPT_TRAFFIC in $traffics; do
91     for kvers in $kernel_versions; do
92         dir="results/host-$(uname -r)/$kvers/$OPT_TRAFFIC/$(basename $0 .sh)"
93         mkdir -p $dir
94         script=$PWD/$0
95         cd $dir
96         echo "Working directory: $dir"
97         if [[ ! "$OPT_PLOT_ONLY" ]]; then
98             # Remove data from the last measurement
99             rm -rf *
100             # Set can interfaces up
101             sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
102             # Delete all vcan interfaces
103             sshgw 'for dev in $(ip l|grep -o vcan[^:]\\+); do ip link del dev $dev; done'
104             # Reset priorities
105             sshgw 'chrt -p -f 50 `pidof irq/145-can0` > /dev/null || :'
106             sshgw 'chrt -p -f 50 `pidof irq/146-can1` > /dev/null || :'
107             sshgw 'chrt -p -f 49 `pidof sirq-net-rx/0` > /dev/null || :'
108             sshgw 'chrt -p -f 49 `pidof sirq-net-tx/0` > /dev/null || :'
109             # Set the length of qdisc queue to avoid ENOBUFS errors
110             ifconfig can0 txqueuelen 200
111             cleanupgw
112
113             main
114             cp $script .
115         fi
116         if [[ ! "$OPT_PLOT_DISABLE" ]]; then
117             _plot
118         fi
119         cd -
120     done
121     done
122 }
123
124 test_end() {
125     test_end_called=t
126     exit_ok=
127     _run
128     exit_ok=t
129 }
130
131 _myexit() {
132     code=$?
133     cmd=$BASH_COMMAND
134     if [[ ! "$test_end_called" ]]; then
135         test_end_called=t
136         error "bug in the test script: No test_end called"
137     fi
138     if ! test -n "$exit_ok"; then
139         error "FATAL: Command '$cmd' exit with code $code"
140     fi
141 }
142
143 trap '_myexit' EXIT